package test;

import javax.servlet.*;
import javax.servlet.http.HttpServlet;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

/**
 * @author Eugene Petrenko (eugene.petrenko@gmail.com)
 *         Date: 17.02.12 20:20
 */
public class SomeServlet extends GenericServlet {
  private ClassLoader myLoader;
  private HttpServlet myServlet;

  public void init(final ServletConfig config) throws ServletException {
    try {
      myLoader = new URLClassLoader(new URL[] {new File(config.getServletContext().getRealPath("/WEB-INF/plugins/plugin.jar")).toURI().toURL()} , getClass().getClassLoader());
    } catch (Exception e) {
      e.printStackTrace();
    }

    doUnderContextClassLoader(myLoader, new FuncThrow<Object, ServletException>() {
      public Object apply() throws ServletException {
        myServlet = new CustomProcessor();
        myServlet.init(config);
        return null;
      }
    });
  }

  public interface FuncThrow<R, E extends Throwable> {
    R apply() throws E;
  }


  public static <T, E extends Throwable> T doUnderContextClassLoader(final ClassLoader cl, FuncThrow<T, E> action) throws E {
    final ClassLoader oldClassLoader = Thread.currentThread().getContextClassLoader();
    Thread.currentThread().setContextClassLoader(cl);
    try {
      return action.apply();
    } finally {
      Thread.currentThread().setContextClassLoader(oldClassLoader);
    }
  }


  @Override
  public void service(ServletRequest req, ServletResponse res) throws ServletException, IOException {
    req.setAttribute("org.apache.catalina.jsp_file", "/plugin/plugin.jsp");
    try {
      req.setAttribute("aaa", myLoader.loadClass("plugin.Bean").newInstance());
    } catch (Exception e) {
      e.printStackTrace();
    }
    myServlet.service(req, res);
  }
}
